/**************************************************************************//**
 *
 * Copyright 1998-2013 NetBurner, Inc.  ALL RIGHTS RESERVED
 *   Permission is hereby granted to purchasers of NetBurner Hardware
 *   to use or modify this computer program for any use as long as the
 *   resultant program is only executed on NetBurner provided hardware.
 *
 *   No other rights to use this program or it's derivatives in part or
 *   in whole are granted.
 *
 *   It may be possible to license this or other NetBurner software for
 *   use on non-NetBurner Hardware.
 *   Please contact sales@Netburner.com for more information.
 *
 *   NetBurner makes no representation or warranties
 *   with respect to the performance of this computer program, and
 *   specifically disclaims any responsibility for any damages,
 *   special or consequential, connected with the use of this program.
 *
 *---------------------------------------------------------------------
 * NetBurner, Inc.
 * 5405 Morehouse Drive
 * San Diego, California 92121
 *
 * information available at:  http://www.netburner.com
 * E-Mail info@netburner.com
 *
 * Support is available: E-Mail support@netburner.com
 *
 *****************************************************************************/
#ifndef  __DATALOG_H
#define  __DATALOG_H

#include <stdint.h>


struct dataStruct {
    int         sensorID;
    uint32_t    timeStamp;
    float       value;
};

typedef void (*RingLogSerializer)( dataStruct *item, void *args );

class RingLog{
    private:
        dataStruct          *pHead;
        dataStruct          *pTail;
        int32_t             count;

        const dataStruct    *pStart;
        const dataStruct    *pEnd;
        const int32_t       maxSize;

        void IncrementTail();
        void IncrementHead();
        void IncrementPtr( dataStruct *&ptr );

    public:
        RingLog( dataStruct *buffer, uint32_t bufferSize );
        ~RingLog();

        void Add( dataStruct *item );
        void Remove( dataStruct *item );
        int32_t GetCount();
        void Dump();
        void Serialize( RingLogSerializer serializer, void *args );
};

#endif   /* ----- #ifndef __DATALOG_H  ----- */
